export type ErrorsByField = {
    [fieldId in string]: Array<ErrorsByField | string>;
};
export type ErrorsByFlatField = {
    [fieldId in string]: string[];
};
export declare class ValidationError extends Error {
    private errorsByField;
    constructor(message: string, errorsByField: ErrorsByField);
    getErrorsByField(): ErrorsByField;
    getErrorsByFlatField(): ErrorsByFlatField;
    protected populateErrorsByFlatField(errorsByField: ErrorsByField, flatMap: ErrorsByFlatField, prefix: string): void;
    getErrorsForField(fieldId: string): string[];
    getErrorsForFieldPath(fieldPath: string[]): string[];
    getErrorsByFieldForFieldPath(fieldPath: string[]): ErrorsByField;
    getErrorsForErrorsByField(errorsByField: ErrorsByField): string[];
}
