"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ValidationError = void 0;
var ValidationError = /** @class */ (function (_super) {
    __extends(ValidationError, _super);
    /* istanbul ignore next */
    function ValidationError(message, errorsByField) {
        var _newTarget = this.constructor;
        var _this = _super.call(this, message) || this;
        _this.errorsByField = errorsByField;
        Object.setPrototypeOf(_this, _newTarget.prototype); // restore prototype chain
        return _this;
    }
    ValidationError.prototype.getErrorsByField = function () {
        return this.errorsByField;
    };
    ValidationError.prototype.getErrorsByFlatField = function () {
        var flatMap = {};
        this.populateErrorsByFlatField(this.errorsByField, flatMap, '');
        return flatMap;
    };
    ValidationError.prototype.populateErrorsByFlatField = function (errorsByField, flatMap, prefix) {
        for (var _i = 0, _a = Object.keys(errorsByField); _i < _a.length; _i++) {
            var fieldId = _a[_i];
            for (var _b = 0, _c = errorsByField[fieldId]; _b < _c.length; _b++) {
                var error = _c[_b];
                if (typeof error === 'string') {
                    var flatFieldId = prefix
                        ? (fieldId === '.' ? prefix : "".concat(prefix, ".").concat(fieldId))
                        : fieldId;
                    var thisErrors = flatMap[flatFieldId] || [];
                    flatMap[flatFieldId] = __spreadArray(__spreadArray([], thisErrors, true), [error], false);
                }
                else {
                    var newPrefix = prefix ? "".concat(prefix, ".").concat(fieldId) : fieldId;
                    this.populateErrorsByFlatField(error, flatMap, newPrefix);
                }
            }
        }
    };
    ValidationError.prototype.getErrorsForField = function (fieldId) {
        return this.getErrorsForFieldPath([fieldId]);
    };
    ValidationError.prototype.getErrorsForFieldPath = function (fieldPath) {
        var errorsByField = this.getErrorsByFieldForFieldPath(fieldPath);
        return this.getErrorsForErrorsByField(errorsByField);
    };
    ValidationError.prototype.getErrorsByFieldForFieldPath = function (fieldPath) {
        var errorsByField = this.errorsByField;
        for (var _i = 0, fieldPath_1 = fieldPath; _i < fieldPath_1.length; _i++) {
            var pathComponent = fieldPath_1[_i];
            var newErrorsByField = {};
            for (var _a = 0, _b = errorsByField[pathComponent] || []; _a < _b.length; _a++) {
                var error = _b[_a];
                if (typeof error === 'string') {
                    var thisErrors = newErrorsByField['.'] || [];
                    newErrorsByField['.'] = __spreadArray(__spreadArray([], thisErrors, true), [error], false);
                }
                else {
                    for (var _c = 0, _d = Object.keys(error); _c < _d.length; _c++) {
                        var fieldId = _d[_c];
                        var errors = error[fieldId];
                        var existingErrors = newErrorsByField[fieldId] || [];
                        newErrorsByField[fieldId] = __spreadArray(__spreadArray([], existingErrors, true), errors, true);
                    }
                }
            }
            errorsByField = newErrorsByField;
        }
        return errorsByField;
    };
    ValidationError.prototype.getErrorsForErrorsByField = function (errorsByField) {
        var _this = this;
        return Object.keys(errorsByField).flatMap(function (fieldId) {
            var prefix = fieldId === '.' ? '' : "Key '".concat(fieldId, "': ");
            return errorsByField[fieldId].flatMap(function (error) {
                if (typeof error === 'string') {
                    return "".concat(prefix).concat(error);
                }
                return _this.getErrorsForErrorsByField(error)
                    .map(function (flatError) { return "".concat(prefix).concat(flatError); });
            });
        });
    };
    return ValidationError;
}(Error));
exports.ValidationError = ValidationError;
//# sourceMappingURL=ValidationError.js.map